'''
Created on Apr 10, 2012

@author: Keith Robertson
'''
import unittest
import ConfigParser
from stratasdk.api import API
from stratasdk.infrastructure.brokers import cases, case, entitlement, solution

__author__ =  'Keith Robertson <kroberts@redhat.com>'

class Test(unittest.TestCase):

    def setUp(self):
        self.config = ConfigParser.ConfigParser()
        self.config.read('strata.cfg')
        self.user = self.config.get('strata','username')
        self.passwd = self.config.get('strata','password')
        self.url = self.config.get('strata','url')
        pass

    def testGetCase(self):
        print "---testGetCase---"
        api = API(username=self.user,
                  password=self.passwd,
                  url=self.url,
                  httpDebug=True,
                  verbose=False)
        caseID = self.config.get('testGetCase','caseID')
        print "Getting case %s" % (caseID)
        case = api.cases.get(caseID)
        e = case.get_entitlement()
        e.toXml()
        case.toXml()
        print '----------'
        case.set_status('Waiting on Red Hat')
        case.update()
        print '----------'
#        assert com is not None
#        assert com.get_createdBy() == self.config.get('testGetComment','createdBy')
        api.disconnect()
        pass

#    def testFilterComments(self):
#        print "---testFilterComments---"
#        api = API(username=self.user,
#                  password=self.passwd,
#                  url=self.url,
#                  httpDebug=False,
#                  verbose=False)
#        caseID = self.config.get('testFilterComments','caseID')
#        comAry = api.comments.list(caseID,
#                                   createdBy=self.config.get('testFilterComments','createdBy'))
#        api.disconnect()
#        assert comAry is not None
#        for com in comAry:
#            print "Found the following comment:"
#            com.toXml()
#        pass

#    def testAddComment(self):
#        print "---testAddComment---"
#        api = API(username=self.user,
#                  password=self.passwd,
#                  url=self.url,
#                  httpDebug=False,
#                  verbose=False)
#
#        com = api.im.makeComment(caseNumber=self.config.get('testAddComment','caseID'),
#                                 text = self.config.get('testAddComment','text'),
#                                 public = self.config.get('testAddComment','public'))
#        # This TC is blocked by https://bugzilla.redhat.com/844465
#        print "---Adding Comment---"
#        doc = api.comments.add(com)
#        assert doc.get_id() is not None
#        print "---Updating solution---"
#        doc.toXml()
#        api.disconnect()
#        pass



if __name__ == "__main__":
    #import sys;sys.argv = ['', 'Test.testName']
    unittest.main()
